/** 
 *------------------------------------------------------------------------------
 * @package       T3 Framework for Joomla!
 *------------------------------------------------------------------------------
 * @copyright     Copyright (C) 2004-2013 JoomlArt.com. All Rights Reserved.
 * @license       GNU General Public License version 2 or later; see LICENSE.txt
 * @authors       JoomlArt, JoomlaBamboo, (contribute to this project at github 
 *                & Google group to become co-author)
 * @Google group: https://groups.google.com/forum/#!forum/t3fw
 * @Link:         http://t3-framework.org 
 *------------------------------------------------------------------------------
 */

 
var JASliderSupport = {
	inited: false,
	
	initialize: function(){
		if(window.jasliderInst && window.jasliderInst.length && !JASliderSupport.inited){

			window.jasliderInst.each(function(inst){
				inst._ooptions = Object.clone(inst.options);
			});
			
			var sid = null;
			window.addEvent('resize', function(){
				clearTimeout(sid);
				sid = setTimeout(JASliderSupport.resize, 100);
			});
			
			JASliderSupport.resize();
			
			JASliderSupport.inited = true;
		}
	},
	resize: function(){
		window.jasliderInst.each(function(instance){

			var ooptions = instance._ooptions,
				options = instance.options,
				
				vars = instance.vars,

				ratio = vars.slider.getWidth() / ooptions.mainWidth,
				nwidth = Math.floor(ooptions.mainWidth * ratio),
				nheight = Math.floor(ooptions.mainHeight * ratio),
				ntwidth = Math.floor(ooptions.thumbWidth * ratio),
				ntheight = Math.floor(ooptions.thumbHeight * ratio);
				
			options.mainWidth = nwidth;
			options.mainHeight = nheight;
			options.mainWidth = nwidth;
			options.thumbWidth = ntwidth;
			options.thumbHeight = ntheight;

			vars.mainWrap.setStyles({
				'width': nwidth,
				'height': nheight
			});

			vars.mainFrame.setStyles({
				'width': nwidth,
				'height': nheight
			});
			
			vars.mainItems.setStyles({
				'width': nwidth,
				'height': nheight
			});
			
			instance.initMasker();
			instance.initThumbAction();
			instance.initMainCtrlButton();
			instance.initProgressBar();

			setTimeout(function(){
				instance.next(true);
			}, 250);
		});
	}
};

(function($){
	$.fn.equalboxes = function(){
		var maxheight = 0,
			rowheight = 0,
			rowstart = 0,
			height = 0,
			boxes = [],
			top = 0,
			jel = null;

		//all equalheight (item will not align like a mess)
		this.each(function(){
			jel = $(this);
			height = jel.css({'height': '', 'min-height': ''}).removeClass('eq-first').height();

			if(height > maxheight){
				maxheight = height;
			}

			jel.data('orgHeight', height);

		}).css('min-height', maxheight);

		//per row equal-height
		this.each(function() {
			jel = $(this);
			height = jel.data('orgHeight');
			top = jel.position().top;

			if (rowstart != top) {
				boxes.length && $(boxes).css('min-height', rowheight + 1).eq(0).addClass('eq-first');

				// set the variables for the new row
				boxes.length = 0;
				rowstart = jel.position().top;
				rowheight = height;
				boxes.push(this);

			} else {
				boxes.push(this);
				if(height > rowheight){
					rowheight = height;
				}
			}
		});

		boxes.length && $(boxes).css('min-height', rowheight + 1).eq(0).addClass('eq-first');

		return this;
	};

	$.fn.liveeqboxs = function(){
		var elms = this,
			rzid = null,
			resize = function () {
				elms.equalboxes();
			};

		$(window).load(function(){
			//trigger one
			elms.equalboxes();

			clearTimeout(rzid);
			rzid = setTimeout(resize, 2000); //just in case something new loaded
		}).on('resize.eqb', function(){
			clearTimeout(rzid);
			rzid = setTimeout(resize, 200);
		});

		//trigger one
		elms.equalboxes();

		return this;
	};

})(jQuery);

(function($){
	$(window).load(function(){
		JASliderSupport.initialize();

		//equalheight
		var rzid = null,
			resize = function(){
				$('#t3-content, .t3-sidebar').equalHeight();

				setTimeout(resize, 1500);
			};

		setTimeout(resize, 100);

		$(window).on('resize', function(){
			clearTimeout(rzid);
			rzid = setTimeout(resize, 200);
		});

		//equal height for megamenu
		$('.mega-dropdown-menu').each(function(){
			var jdropdown = $(this),
				odisplay = jdropdown.css('display');
				
			if(odisplay == 'none'){
				jdropdown.css('display', 'block');
			}
			
			jdropdown.find(' > .row-fluid > .mega-col-module').equalHeight();

			if(odisplay == 'none'){
				jdropdown.css('display', '');
			}
		});
	});

	//fix validate.js error
	if(Browser.ie && Browser.version <= 8){
		Browser.Features.inputemail = false;
	}

})(jQuery);


(function($) {

	$(document).ready(function ($) {
		// back to top
		(function(){
			$('#back-to-top').on('click', function(){
				$('html, body').stop(true).animate({
					scrollTop: 0
				}, {
					duration: 800, 
					easing: 'easeInOutCubic',
					complete: window.reflow
				});

				return false;
			});
		})();

		//equalheight
		(function(){
    		$('#t3-content, .t3-sidebar').equalHeight();

    		//equal height for megamenu
			$('.mega-dropdown-menu').each(function(){
				var jdropdown = $(this),
					odisplay = jdropdown.css('display');

				if(odisplay == 'none'){
					jdropdown.css('display', 'block');
				}
				
				jdropdown.find(' > .row-fluid > .mega-col-module').equalHeight();

				if(odisplay == 'none'){
					jdropdown.css('display', '');
				}
			});
		})();
	});
})(jQuery);