<?php
/**
 * @package   T3 Blank
 * @copyright Copyright (C) 2005 - 2012 Open Source Matters, Inc. All rights reserved.
 * @license   GNU General Public License version 2 or later; see LICENSE.txt
 */

/**
 * Mainbody 3 columns, content in center: sidebar1 - content - sidebar2
 */
defined('_JEXEC') or die;
?>
<?php

  // Layout configuration
  $layout_config = json_decode ('{
    "two_sidebars": {
      "default" : [ "span7 offset3" , "span3 offset-10"    , "span2"             ],
      "wide"    : [],
      "xtablet" : [],
      "tablet"  : [ "span12"        , "span6 spanfirst"   , "span6"             ]
    },
    "one_sidebar1": {
	  "default" : [ "span9 pull-right no-right"         , "span3"             ],
	  "wide"    : [],
	  "xtablet" : [ "span8 pull-right"         , "span4"             ],
      "tablet"  : [ "span12"        , "span12 spanfirst"  ]
    },
    "one_sidebar2": {
      "default" : [ "span9 no-left"         , "span3"             ],
      "wide"    : [],
      "xtablet" : [ "span8"         , "span4"             ],
      "tablet"  : [ "span12"        , "span12 spanfirst"  ]
    },
    "no_sidebar": {
      "default" : [ "span12 no-sidebar" ]
    }
  }');

  // positions configuration
  $mastcol  = 'mast-col';
  $sidebar1 = 'position-5';
  $sidebar2 = 'position-7';
  // Detect layout
  if ($this->countModules("$sidebar1 and $sidebar2")) {
    $layout = 'two_sidebars';
  } elseif ($this->countModules($sidebar1)) {
    $layout = 'one_sidebar1';
  } elseif ($this->countModules($sidebar2)) {
    $layout = 'one_sidebar2';
  } else {
    $layout = 'no_sidebar';
  }
  $layout = $layout_config->$layout;

  $col = 0;
?>

<section id="t3-mainbody" class="wrap t3-mainbody home-page">
  <div class="container">
	  <div class="row">
		
		<!-- MAIN CONTENT -->
		<div id="t3-content" class="t3-content <?php echo $this->getClass($layout, $col) ?>" <?php echo $this->getData ($layout, $col++) ?>>
			<div class="top-content clearfix">
				<div class="top-slideshow<?php $this->_c('slideshow')?>">
				  <jdoc:include type="modules" name="<?php $this->_p('slideshow') ?>" style="T3Xhtml" />
				</div>  
				<div class="top-sidenews<?php $this->_c('sidenews')?>">
					<jdoc:include type="modules" name="<?php $this->_p('sidenews') ?>" style="T3Xhtml" />
				</div>
			 </div>
		  <?php if ($this->countModules($mastcol)) : ?>
			<!-- MASSCOL 1 -->
			<div class="ja-mastcol ja-mastcol-1<?php $this->_c($mastcol)?>">
			  <jdoc:include type="modules" name="<?php $this->_p($mastcol) ?>" style="T3Xhtml" />
			</div>
			<!-- //MASSCOL 1 -->
		  <?php endif ?>
		  <?php if($this->hasMessage()):?>
		  <jdoc:include type="message" />
		  <?php endif; ?>
		  
		</div>
		<!-- //MAIN CONTENT -->

		<?php if ($this->countModules($sidebar1)) : ?>
		<!-- SIDEBAR 1 -->
		<div class="t3-sidebar t3-sidebar-1 <?php echo $this->getClass($layout, $col) ?><?php $this->_c($sidebar1)?>" <?php echo $this->getData ($layout, $col++) ?>>
		  <jdoc:include type="modules" name="<?php $this->_p($sidebar1) ?>" style="T3Xhtml" />
		</div>
		<!-- //SIDEBAR 1 -->
		<?php endif ?>
		
		<?php if ($this->countModules($sidebar2)) : ?>
		<!-- SIDEBAR 2 -->
		<div class="t3-sidebar t3-sidebar-2 <?php echo $this->getClass($layout, $col) ?><?php $this->_c($sidebar2)?>" <?php echo $this->getData ($layout, $col++) ?>>
		  <jdoc:include type="modules" name="<?php $this->_p($sidebar2) ?>" style="T3Xhtml" />
		</div>
		<!-- //SIDEBAR 2 -->
		<?php endif ?> 
	  </div>
  </div>
</section> 