<?php
/**
 * @package   T3 Blank
 * @copyright Copyright (C) 2005 - 2012 Open Source Matters, Inc. All rights reserved.
 * @license   GNU General Public License version 2 or later; see LICENSE.txt
 */

/**
 * Mainbody 3 columns, content in right, sidebar1 - sidebar2 - content
 */
defined('_JEXEC') or die;
?>

<?php

// Layout configuration
$layout_config = json_decode ('{  
	"one_sidebar": {
		"default" : [ "span9 pull-right no-right",		"span3",				"span3"             ],
		"wide"    : [],
		"xtablet" : [ "span8 pull-right no-right",		"span4",				"span4"             ],
		"tablet"  : [ "span12",							"span12 spanfirst",		"span12"            ]
	},
	"no_sidebar": {
		"default" : [ "span12" ]
	}
}');

  // positions configuration
$mastcol  = 'mast-col';
$sidebar1 = 'position-5';

  // Detect layout
if ($this->countModules($sidebar1)) {
	$layout = 'one_sidebar';
} else {
	$layout = 'no_sidebar';
}

$layout = $layout_config->$layout;

$col = 0;
?>

<section id="t3-mainbody" class="t3-mainbody main-right wrap">
	<div class="container">
		<div class="row">
			
			<!-- MAIN CONTENT -->
			<div id="t3-content" class="t3-content <?php echo $this->getClass($layout, $col) ?>" <?php echo $this->getData ($layout, $col++) ?>>
				<div class="main-content">
					<?php if ($this->countModules($mastcol)) : ?>
					<!-- MASSCOL 1 -->
					<div class="ja-mastcol ja-mastcol-1<?php $this->_c($mastcol)?>">
						<jdoc:include type="modules" name="<?php $this->_p($mastcol) ?>" style="T3Xhtml" />
					</div>
					<!-- //MASSCOL 1 -->
					<?php endif ?>
					<?php if($this->hasMessage()):?>
					<jdoc:include type="message" />
					<?php endif; ?>

					<div class="main-container1">
						<jdoc:include type="component" />
					</div>
				</div>
			</div>
			<!-- //MAIN CONTENT -->

			<?php if ($this->countModules($sidebar1)) : ?>
			<!-- SIDEBAR 1 -->
			<div class="t3-sidebar t3-sidebar-1 <?php echo $this->getClass($layout, $col) ?><?php $this->_c($sidebar1)?>" <?php echo $this->getData ($layout, $col++) ?>>
				<jdoc:include type="modules" name="<?php $this->_p($sidebar1) ?>" style="T3Xhtml" />
			</div>
			<!-- //SIDEBAR 1 -->
			<?php endif ?>

		</div>
	</div>
</section> 